#!/usr/bin/python3

'''
Before running this program, you need to install postgeSQL and enable remote TCP/IP access to it.

files to edit:
/etc/postgresql/12/main/pg_hba.conf
/etc/postgresql/12/main/postgresql.conf

Need to create a Database and Role (for example, DBNAME)
$ sudo -su postgres
$ psql

create role DBNAME with createrole login password 'password';
create database DBNAME;
grant all on database DBNAME to DBNAME;
create user dummy with password 'dum123';
------------------------------------------------

This program creates:
table coursedetails
permit user 'dummy' to read coursedetails 
permit user 'reader' to read the course data.
'''

import psycopg2, sys, getpass

port = 5432

if len(sys.argv) != 3:
	print ('Usage: python3 initQbank.py hostname databasename')
	sys.exit(0)

host = sys.argv[1]
mydb = sys.argv[2]
passwd = getpass.getpass('Enter Database password : ')
user = mydb

conn = psycopg2.connect(database=mydb, host=host, user=user, password=passwd, port=port)
cursor = conn.cursor()

[('code',), ('syllabusyear',), ('inst',), ('name',), ('subject',), ('degree',), ('semester',), ('texlanguage',), ('qpmodel',), ('duration',), ('nmodules',), ('code2',), ('code3',)]

sql = 'create table if not exists coursedetails(code varchar,syllabusYear varchar, inst varchar, name varchar, faculty varchar, degree varchar, semester varchar, texLanguage varchar, qpmodel varchar, duration varchar, nmodules varchar, code2 varchar, code3 varchar);'
if 1:
	cursor.execute(sql)
	print('Table "coursedetails" created')
	conn.commit()	
else:
	print('Creating Table "coursedetails" failed')
	sys.exit(0)

sql = 'grant select on coursedetails to reader;'
cursor.execute(sql)
conn.commit()	

sql = 'grant select on coursedetails to dummy;'
cursor.execute(sql)
conn.commit()	
